   module module_updateOcn
      implicit none
      integer :: ixrt,jxrt
      integer, allocatable,dimension(:,:) :: CHANNELGRID, FLOWDIRECTION
      real, allocatable,dimension(:,:) :: TOPOGRAPHY
   contains
      subroutine run(fulldomFile)
        implicit none
        character(len=256) :: fulldomFile
        integer :: i, j
!!! get ixrt
!!! get jxrt
        call get_file_dimension0(trim(fulldomFile), "x", ixrt) 
        call get_file_dimension0(trim(fulldomFile), "y", jxrt) 
        allocate(CHANNELGRID(ixrt,jxrt))
        allocate(FLOWDIRECTION(ixrt,jxrt))
        allocate(TOPOGRAPHY(ixrt,jxrt))
        call get2d_real("TOPOGRAPHY",TOPOGRAPHY,ixrt,jxrt,trim(fulldomFile))
        call get2d_int("CHANNELGRID",CHANNELGRID,ixrt,jxrt,trim(fulldomFile))
        call get2d_int("FLOWDIRECTION",FLOWDIRECTION,ixrt,jxrt,trim(fulldomFile))
        do j = 1, jxrt
        do i = 1, ixrt
           if(CHANNELGRID(i,j) .eq. 0 .and. TOPOGRAPHY(i,j) .le. 0) then
              CHANNELGRID(i,j) = -9999
           endif
        enddo
        enddo
        call output(fulldomFile)
      end subroutine run

      subroutine output(fulldomFile)
          implicit none
          character(len=256) :: fulldomFile
#include <netcdf.inc>
          integer ::iret, ncid, varid
          iret = nf_open(trim(fulldomFile), NF_WRITE, ncid)
          iret = nf_inq_varid(ncid,"CHANNELGRID",  varid)
          iret = nf_put_var_int(ncid,varid,CHANNELGRID)
          iret=nf_close(ncid)
      end subroutine output
      
   end module module_updateOcn

   program main
         use module_updateOcn, only : run
         implicit none
          character(len=256) :: fulldomFile

         integer :: narg
         intrinsic ::  iargc

         narg = IARGC()
         write(6,*) "narg = ", narg
        if(narg .lt. 1) then
          print*, " update the channelgrid to be -9999 when elevation <= 0 "
          stop "Usage: updateOcn.exe FulldomFile"
        endif

         call getarg(1,fullDomFile)
         call run(fullDomFile)

        stop 
   end
