!  Program Name:
!  Author(s)/Contact(s): Wei Yu
! 
!  User controllable options: <if applicable>

program data_hydro
! This is the main program of data hydrology model 

   use module_dhydro, only: dhydro_ini, dhydro_exe, dabiaLoop, interFace_drv
   use module_namelist, only: nlst_rt
   use module_channelUpdate, only:  bias2m
   use module_rami_hybridDa, only: segInfoFile
   use module_mpp_land, only: my_id, io_id

   implicit none

   integer :: k, dabiaLoopOpt, did, mLoop
   parameter(did = 1)
   character(len=1) ss
   logical :: fexist
   

   call interFace_drv()
   if(nlst_rt(did)%CHANRTSWCRT .eq. 0) then 
      write(6,*) "Warning: reset nlst_rt(did)%CHANRTSWCRT to be 1 .. "
      nlst_rt(did)%CHANRTSWCRT=1
   endif

   call dhydro_ini()

   if(nlst_rt(did)%DABE .eq. 0) dabiaLoop = 0

!   write(6,*)  " DABE = ", nlst_rt(did)%DABE, "dabiaLoop = ", dabiaLoop

   if(dabiaLoop .gt. 0 .or. dabiaLoop .lt. 0) call daBiaLoop_ini_drv()

   mLoop = 0
   if(dabiaLoop .gt. 0) mLoop = dabiaLoop

   do k = 0, mLoop
       if(my_id .eq. io_id) then
          write(ss,"(I1)") k
          inquire (file=trim(ss), exist=fexist)
          if(.not. fexist) then 
            call system("mkdir "//ss)
            inquire (file=trim(segInfoFile), exist=fexist)
            if(fexist) call system("cp "//trim(segInfoFile)//" "//ss)
            inquire (file="factor.nc", exist=fexist)
            if(fexist) call system("cp factor.nc "//ss)
          endif
       endif
       call resetIni()
       write(6,*) " finish reset Ini .... "
       call dhydro_exe()

       if(dabiaLoop .gt. 0 .or. dabiaLoop .lt. 0) call dumpPair_drv(k)

       if( (k .ne. mLoop .and. mLoop .gt. 0) .or. mLoop .eq. 0 ) then
          call daBiaRun_drv(k)
       else
          if(nlst_rt(did)%sysErrOut .ge. 1 .and. mLoop .gt. 0) call bias2m()
          write(6,*)  "call hydro_finish from main_dhydro.F"
          call hydro_finish()
       endif
       if(mLoop .eq. 0 .or. dabiaLoop .le. 0) call hydro_finish()
   enddo
          call hydro_finish()
END 

